--- old/usr/src/uts/intel/ia32/ml/i86_subr.s	2014-11-14 18:05:27.658349014 -0500
+++ new/usr/src/uts/intel/ia32/ml/i86_subr.s	2014-11-14 18:05:27.663438794 -0500
@@ -2801,7 +2801,8 @@
 
 	ENTRY(lowbit)
 	movl	$-1, %eax
-	bsfq	%rdi, %rax
+	bsfq	%rdi, %rdi
+	cmovnz	%edi, %eax
 	incl	%eax
 	ret
 	SET_SIZE(lowbit)
@@ -2809,10 +2810,13 @@
 #elif defined(__i386)
 
 	ENTRY(lowbit)
-	movl	$-1, %eax
 	bsfl	4(%esp), %eax
+	jz	0f
 	incl	%eax
 	ret
+0:
+	xorl	%eax, %eax
+	ret
 	SET_SIZE(lowbit)
 
 #endif	/* __i386 */
@@ -2825,60 +2829,41 @@
 highbit(ulong_t i)
 { return (0); }
 
+/*ARGSUSED*/
+int
+highbit64(uint64_t i)
+{ return (0); }
+
 #else	/* __lint */
 
 #if defined(__amd64)
 
 	ENTRY(highbit)
+	ALTENTRY(highbit64)
 	movl	$-1, %eax
-	bsrq	%rdi, %rax
+	bsrq	%rdi, %rdi
+	cmovnz	%edi, %eax
 	incl	%eax
 	ret
+	SET_SIZE(highbit64)
 	SET_SIZE(highbit)
 
 #elif defined(__i386)
 
 	ENTRY(highbit)
-	movl	$-1, %eax
 	bsrl	4(%esp), %eax
+	jz	0f
 	incl	%eax
 	ret
+0:
+	xorl	%eax, %eax
+	ret    
 	SET_SIZE(highbit)
 
-#endif	/* __i386 */
-#endif	/* __lint */
-
-#if defined(__lint)
-
-/*ARGSUSED*/
-int
-highbit64(uint64_t i)
-{ return (0); }
-
-#else	/* __lint */
-
-#if defined(__amd64)
-
-	ENTRY(highbit64)
-	movl	$-1, %eax
-	bsrq	%rdi, %rax
-	incl	%eax
-	ret
-	SET_SIZE(highbit64)
-
-#elif defined(__i386)
-
 	ENTRY(highbit64)
 	bsrl	8(%esp), %eax
-	jz	.lowbit
-	addl	$32, %eax
-	jmp	.done
-
-.lowbit:
-	movl	$-1, %eax
-	bsrl	4(%esp), %eax
-.done:
-	incl	%eax
+	jz	highbit
+	addl	$33, %eax
 	ret
 	SET_SIZE(highbit64)
 
